package com.schbrain.archetype.initializer.backend.maven;

import cn.hutool.core.io.FileUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.maven.cli.MavenCli;

import java.io.File;

/**
 * @author liaozan
 * @since 2022/3/20
 */
@Slf4j
public class MavenUtils {

    public static void generate(String groupId, String artifactId) {
        MavenCli cli = new MavenCli();
        System.getProperties().setProperty("maven.multiModuleProjectDirectory", "$M2_HOME");
        String tmpDirPath = FileUtil.getTmpDirPath();
        File archetype = new File(tmpDirPath, artifactId);
        String[] args = getArgs(groupId, artifactId, archetype.getAbsolutePath());
        cli.doMain(args, null, System.out, System.err);
        log.info("Generate archetype project at {}", archetype.getAbsolutePath());
    }

    @SuppressWarnings("SpellCheckingInspection")
    private static String[] getArgs(String groupId, String artifactId, String outputDirectory) {
        return new String[]{
                "-B",
                "archetype:generate",
                "-DarchetypeGroupId=com.schbrain.kp",
                "-DarchetypeArtifactId=schbrain-archetype",
                "-DarchetypeVersion=1.0-SNAPSHOT",
                String.format("-DoutputDirectory=%s", outputDirectory),
                String.format("-DgroupId=%s", groupId),
                String.format("-DartifactId=%S", artifactId)
        };
    }

}